/*****************************************************
           File Name: EDITRANG.H
         Description: Include file for EDITRANG.C
         Portability: MS Windows, Any memory model,
                      Any windows compatable C Compiler
******************************************************/
#if !defined ( EDITRANG_DEFINED )
    
   /* Styles corresponding to
   ** functions in ctype.h
   ** ECRS is short for:
   ** Edit Range Style */
   #define ERS_ALNUM       1
   #define ERS_ALPHA       2
   #define ERS_CNTRL       4
   #define ERS_DIGIT       8
   #define ERS_GRAPH      16
   #define ERS_LOWER      32
   #define ERS_PRINT      64
   #define ERS_PUNCT     128
   #define ERS_SPACE     256
   #define ERS_UPPER     512
   #define ERS_XDIGIT   1024
   #define ERS_TOLOWER  2048
   #define ERS_TOUPPER  4096

   /* produce a beep when a character is rejected */
   #define ERS_BEEP     8192
   /* produce message box when a character is rejected */
   #define ERS_MESSAGE 16384
   /* specify a special range of characters */
   #define ERS_SPECIAL 32768

   /* Byte offsets for acessing data */
   #define OFFSET_STYLE 0
   #define OFFSET_SPECIALCHARS sizeof( WORD )
   #define OFFSET_MEMFLAG ( OFFSET_SPECIALCHARS + \
         sizeof( LPSTR ) )
   #define ER_WNDEXTRA (int)( sizeof( WORD ) + \
         sizeof( LPSTR ) + sizeof( WORD ) )
   #define ER_CLSEXTRA (int)( sizeof( WORD ) + \
         sizeof( LPSTR ) + sizeof( FARPROC ) )

   LRESULT CALLBACK EditRangeProc( HWND hWnd,
      UINT wMessage, WPARAM wParam, LPARAM lParam );
   #define EDITRANG_DEFINED
#endif
